/**
 * @fileoverview gRPC-Web generated client stub for gcloud.oauth
 * @enhanceable
 * @public
 */

// GENERATED CODE -- DO NOT EDIT!


/* eslint-disable */
// @ts-nocheck



const grpc = {};
grpc.web = require('grpc-web');


var google_protobuf_timestamp_pb = require('google-protobuf/google/protobuf/timestamp_pb.js')

var google_protobuf_empty_pb = require('google-protobuf/google/protobuf/empty_pb.js')

var google_protobuf_wrappers_pb = require('google-protobuf/google/protobuf/wrappers_pb.js')

var gcloud_protobuf_basic_pb = require('gcloud-core-vue/src/gcloud/protobuf/basic_pb.js')
const proto = {};
proto.gcloud = {};
proto.gcloud.oauth = require('./oauth_pb.js');

/**
 * @param {string} hostname
 * @param {?Object} credentials
 * @param {?grpc.web.ClientOptions} options
 * @constructor
 * @struct
 * @final
 */
proto.gcloud.oauth.OauthClient =
    function(hostname, credentials, options) {
  if (!options) options = {};
  options.format = 'binary';

  /**
   * @private @const {!grpc.web.GrpcWebClientBase} The client
   */
  this.client_ = new grpc.web.GrpcWebClientBase(options);

  /**
   * @private @const {string} The hostname
   */
  this.hostname_ = hostname;

};


/**
 * @param {string} hostname
 * @param {?Object} credentials
 * @param {?grpc.web.ClientOptions} options
 * @constructor
 * @struct
 * @final
 */
proto.gcloud.oauth.OauthPromiseClient =
    function(hostname, credentials, options) {
  if (!options) options = {};
  options.format = 'binary';

  /**
   * @private @const {!grpc.web.GrpcWebClientBase} The client
   */
  this.client_ = new grpc.web.GrpcWebClientBase(options);

  /**
   * @private @const {string} The hostname
   */
  this.hostname_ = hostname;

};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.OAuthPassword,
 *   !proto.gcloud.oauth.OAuthAccessToken>}
 */
const methodDescriptor_Oauth_authorizePwd = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/authorizePwd',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.OAuthPassword,
  proto.gcloud.oauth.OAuthAccessToken,
  /**
   * @param {!proto.gcloud.oauth.OAuthPassword} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.OAuthAccessToken.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.OAuthPassword} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.OAuthAccessToken)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.OAuthAccessToken>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.authorizePwd =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/authorizePwd',
      request,
      metadata || {},
      methodDescriptor_Oauth_authorizePwd,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.OAuthPassword} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.OAuthAccessToken>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.authorizePwd =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/authorizePwd',
      request,
      metadata || {},
      methodDescriptor_Oauth_authorizePwd);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.OAuthPasswordVerifyCode,
 *   !proto.gcloud.oauth.OAuthAccessToken>}
 */
const methodDescriptor_Oauth_authorizePwdVerify = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/authorizePwdVerify',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.OAuthPasswordVerifyCode,
  proto.gcloud.oauth.OAuthAccessToken,
  /**
   * @param {!proto.gcloud.oauth.OAuthPasswordVerifyCode} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.OAuthAccessToken.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.OAuthPasswordVerifyCode} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.OAuthAccessToken)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.OAuthAccessToken>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.authorizePwdVerify =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/authorizePwdVerify',
      request,
      metadata || {},
      methodDescriptor_Oauth_authorizePwdVerify,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.OAuthPasswordVerifyCode} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.OAuthAccessToken>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.authorizePwdVerify =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/authorizePwdVerify',
      request,
      metadata || {},
      methodDescriptor_Oauth_authorizePwdVerify);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.OAuthPhoneAndCode,
 *   !proto.gcloud.oauth.OAuthAccessToken>}
 */
const methodDescriptor_Oauth_authorizePhone = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/authorizePhone',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.OAuthPhoneAndCode,
  proto.gcloud.oauth.OAuthAccessToken,
  /**
   * @param {!proto.gcloud.oauth.OAuthPhoneAndCode} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.OAuthAccessToken.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.OAuthPhoneAndCode} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.OAuthAccessToken)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.OAuthAccessToken>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.authorizePhone =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/authorizePhone',
      request,
      metadata || {},
      methodDescriptor_Oauth_authorizePhone,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.OAuthPhoneAndCode} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.OAuthAccessToken>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.authorizePhone =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/authorizePhone',
      request,
      metadata || {},
      methodDescriptor_Oauth_authorizePhone);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.google.protobuf.StringValue,
 *   !proto.gcloud.oauth.OAuthAccessToken>}
 */
const methodDescriptor_Oauth_refreshToken = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/refreshToken',
  grpc.web.MethodType.UNARY,
  google_protobuf_wrappers_pb.StringValue,
  proto.gcloud.oauth.OAuthAccessToken,
  /**
   * @param {!proto.google.protobuf.StringValue} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.OAuthAccessToken.deserializeBinary
);


/**
 * @param {!proto.google.protobuf.StringValue} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.OAuthAccessToken)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.OAuthAccessToken>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.refreshToken =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/refreshToken',
      request,
      metadata || {},
      methodDescriptor_Oauth_refreshToken,
      callback);
};


/**
 * @param {!proto.google.protobuf.StringValue} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.OAuthAccessToken>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.refreshToken =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/refreshToken',
      request,
      metadata || {},
      methodDescriptor_Oauth_refreshToken);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.google.protobuf.StringValue,
 *   !proto.google.protobuf.BoolValue>}
 */
const methodDescriptor_Oauth_findPhoneIsExist = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/findPhoneIsExist',
  grpc.web.MethodType.UNARY,
  google_protobuf_wrappers_pb.StringValue,
  google_protobuf_wrappers_pb.BoolValue,
  /**
   * @param {!proto.google.protobuf.StringValue} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  google_protobuf_wrappers_pb.BoolValue.deserializeBinary
);


/**
 * @param {!proto.google.protobuf.StringValue} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.google.protobuf.BoolValue)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.google.protobuf.BoolValue>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.findPhoneIsExist =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/findPhoneIsExist',
      request,
      metadata || {},
      methodDescriptor_Oauth_findPhoneIsExist,
      callback);
};


/**
 * @param {!proto.google.protobuf.StringValue} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.google.protobuf.BoolValue>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.findPhoneIsExist =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/findPhoneIsExist',
      request,
      metadata || {},
      methodDescriptor_Oauth_findPhoneIsExist);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.SendSmsReq,
 *   !proto.google.protobuf.BoolValue>}
 */
const methodDescriptor_Oauth_sendSms = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/sendSms',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.SendSmsReq,
  google_protobuf_wrappers_pb.BoolValue,
  /**
   * @param {!proto.gcloud.oauth.SendSmsReq} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  google_protobuf_wrappers_pb.BoolValue.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.SendSmsReq} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.google.protobuf.BoolValue)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.google.protobuf.BoolValue>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.sendSms =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/sendSms',
      request,
      metadata || {},
      methodDescriptor_Oauth_sendSms,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.SendSmsReq} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.google.protobuf.BoolValue>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.sendSms =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/sendSms',
      request,
      metadata || {},
      methodDescriptor_Oauth_sendSms);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.VerifyUserPhoneReq,
 *   !proto.google.protobuf.StringValue>}
 */
const methodDescriptor_Oauth_verifyUserPhone = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/verifyUserPhone',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.VerifyUserPhoneReq,
  google_protobuf_wrappers_pb.StringValue,
  /**
   * @param {!proto.gcloud.oauth.VerifyUserPhoneReq} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  google_protobuf_wrappers_pb.StringValue.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.VerifyUserPhoneReq} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.google.protobuf.StringValue)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.google.protobuf.StringValue>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.verifyUserPhone =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/verifyUserPhone',
      request,
      metadata || {},
      methodDescriptor_Oauth_verifyUserPhone,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.VerifyUserPhoneReq} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.google.protobuf.StringValue>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.verifyUserPhone =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/verifyUserPhone',
      request,
      metadata || {},
      methodDescriptor_Oauth_verifyUserPhone);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.ResetUserPwdReq,
 *   !proto.google.protobuf.BoolValue>}
 */
const methodDescriptor_Oauth_resetUserPwd = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/resetUserPwd',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.ResetUserPwdReq,
  google_protobuf_wrappers_pb.BoolValue,
  /**
   * @param {!proto.gcloud.oauth.ResetUserPwdReq} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  google_protobuf_wrappers_pb.BoolValue.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.ResetUserPwdReq} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.google.protobuf.BoolValue)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.google.protobuf.BoolValue>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.resetUserPwd =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/resetUserPwd',
      request,
      metadata || {},
      methodDescriptor_Oauth_resetUserPwd,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.ResetUserPwdReq} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.google.protobuf.BoolValue>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.resetUserPwd =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/resetUserPwd',
      request,
      metadata || {},
      methodDescriptor_Oauth_resetUserPwd);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.UserAddReq,
 *   !proto.gcloud.oauth.UserDto>}
 */
const methodDescriptor_Oauth_registerUser = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/registerUser',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.UserAddReq,
  proto.gcloud.oauth.UserDto,
  /**
   * @param {!proto.gcloud.oauth.UserAddReq} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.UserDto.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.UserAddReq} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.UserDto)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.UserDto>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.registerUser =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/registerUser',
      request,
      metadata || {},
      methodDescriptor_Oauth_registerUser,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.UserAddReq} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.UserDto>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.registerUser =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/registerUser',
      request,
      metadata || {},
      methodDescriptor_Oauth_registerUser);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.ResetPwdReq,
 *   !proto.google.protobuf.BoolValue>}
 */
const methodDescriptor_Oauth_resetPwd = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/resetPwd',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.ResetPwdReq,
  google_protobuf_wrappers_pb.BoolValue,
  /**
   * @param {!proto.gcloud.oauth.ResetPwdReq} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  google_protobuf_wrappers_pb.BoolValue.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.ResetPwdReq} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.google.protobuf.BoolValue)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.google.protobuf.BoolValue>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.resetPwd =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/resetPwd',
      request,
      metadata || {},
      methodDescriptor_Oauth_resetPwd,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.ResetPwdReq} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.google.protobuf.BoolValue>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.resetPwd =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/resetPwd',
      request,
      metadata || {},
      methodDescriptor_Oauth_resetPwd);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.WeiXinLoginRequest,
 *   !proto.gcloud.oauth.WeiXinLoginRespose>}
 */
const methodDescriptor_Oauth_weiXinLogin = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/weiXinLogin',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.WeiXinLoginRequest,
  proto.gcloud.oauth.WeiXinLoginRespose,
  /**
   * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.WeiXinLoginRespose.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.WeiXinLoginRespose)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.WeiXinLoginRespose>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.weiXinLogin =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weiXinLogin',
      request,
      metadata || {},
      methodDescriptor_Oauth_weiXinLogin,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.WeiXinLoginRespose>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.weiXinLogin =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weiXinLogin',
      request,
      metadata || {},
      methodDescriptor_Oauth_weiXinLogin);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.WeiXinRegisterRequest,
 *   !proto.gcloud.oauth.WeiXinRegisterRespose>}
 */
const methodDescriptor_Oauth_weiXinRegister = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/weiXinRegister',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.WeiXinRegisterRequest,
  proto.gcloud.oauth.WeiXinRegisterRespose,
  /**
   * @param {!proto.gcloud.oauth.WeiXinRegisterRequest} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.WeiXinRegisterRespose.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.WeiXinRegisterRequest} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.WeiXinRegisterRespose)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.WeiXinRegisterRespose>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.weiXinRegister =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weiXinRegister',
      request,
      metadata || {},
      methodDescriptor_Oauth_weiXinRegister,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.WeiXinRegisterRequest} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.WeiXinRegisterRespose>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.weiXinRegister =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weiXinRegister',
      request,
      metadata || {},
      methodDescriptor_Oauth_weiXinRegister);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.UserAccessLog,
 *   !proto.google.protobuf.StringValue>}
 */
const methodDescriptor_Oauth_insertUserAccessLog = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/insertUserAccessLog',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.UserAccessLog,
  google_protobuf_wrappers_pb.StringValue,
  /**
   * @param {!proto.gcloud.oauth.UserAccessLog} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  google_protobuf_wrappers_pb.StringValue.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.UserAccessLog} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.google.protobuf.StringValue)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.google.protobuf.StringValue>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.insertUserAccessLog =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/insertUserAccessLog',
      request,
      metadata || {},
      methodDescriptor_Oauth_insertUserAccessLog,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.UserAccessLog} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.google.protobuf.StringValue>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.insertUserAccessLog =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/insertUserAccessLog',
      request,
      metadata || {},
      methodDescriptor_Oauth_insertUserAccessLog);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.WeiXinLoginRequest,
 *   !proto.gcloud.oauth.WeiXinLoginRespose>}
 */
const methodDescriptor_Oauth_weiXinLoginH = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/weiXinLoginH',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.WeiXinLoginRequest,
  proto.gcloud.oauth.WeiXinLoginRespose,
  /**
   * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.WeiXinLoginRespose.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.WeiXinLoginRespose)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.WeiXinLoginRespose>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.weiXinLoginH =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weiXinLoginH',
      request,
      metadata || {},
      methodDescriptor_Oauth_weiXinLoginH,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.WeiXinLoginRespose>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.weiXinLoginH =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weiXinLoginH',
      request,
      metadata || {},
      methodDescriptor_Oauth_weiXinLoginH);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.WxHRequest,
 *   !proto.gcloud.oauth.WeiXinRegisterRespose>}
 */
const methodDescriptor_Oauth_weiXinRegisterH = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/weiXinRegisterH',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.WxHRequest,
  proto.gcloud.oauth.WeiXinRegisterRespose,
  /**
   * @param {!proto.gcloud.oauth.WxHRequest} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.WeiXinRegisterRespose.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.WxHRequest} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.WeiXinRegisterRespose)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.WeiXinRegisterRespose>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.weiXinRegisterH =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weiXinRegisterH',
      request,
      metadata || {},
      methodDescriptor_Oauth_weiXinRegisterH,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.WxHRequest} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.WeiXinRegisterRespose>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.weiXinRegisterH =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weiXinRegisterH',
      request,
      metadata || {},
      methodDescriptor_Oauth_weiXinRegisterH);
};


/**
 * @const
 * @type {!grpc.web.MethodDescriptor<
 *   !proto.gcloud.oauth.WeiXinLoginRequest,
 *   !proto.gcloud.oauth.OAuthAccessToken>}
 */
const methodDescriptor_Oauth_weixinAutoLogin = new grpc.web.MethodDescriptor(
  '/gcloud.oauth.Oauth/weixinAutoLogin',
  grpc.web.MethodType.UNARY,
  proto.gcloud.oauth.WeiXinLoginRequest,
  proto.gcloud.oauth.OAuthAccessToken,
  /**
   * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request
   * @return {!Uint8Array}
   */
  function(request) {
    return request.serializeBinary();
  },
  proto.gcloud.oauth.OAuthAccessToken.deserializeBinary
);


/**
 * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request The
 *     request proto
 * @param {?Object<string, string>} metadata User defined
 *     call metadata
 * @param {function(?grpc.web.RpcError, ?proto.gcloud.oauth.OAuthAccessToken)}
 *     callback The callback function(error, response)
 * @return {!grpc.web.ClientReadableStream<!proto.gcloud.oauth.OAuthAccessToken>|undefined}
 *     The XHR Node Readable Stream
 */
proto.gcloud.oauth.OauthClient.prototype.weixinAutoLogin =
    function(request, metadata, callback) {
  return this.client_.rpcCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weixinAutoLogin',
      request,
      metadata || {},
      methodDescriptor_Oauth_weixinAutoLogin,
      callback);
};


/**
 * @param {!proto.gcloud.oauth.WeiXinLoginRequest} request The
 *     request proto
 * @param {?Object<string, string>=} metadata User defined
 *     call metadata
 * @return {!Promise<!proto.gcloud.oauth.OAuthAccessToken>}
 *     Promise that resolves to the response
 */
proto.gcloud.oauth.OauthPromiseClient.prototype.weixinAutoLogin =
    function(request, metadata) {
  return this.client_.unaryCall(this.hostname_ +
      '/gcloud.oauth.Oauth/weixinAutoLogin',
      request,
      metadata || {},
      methodDescriptor_Oauth_weixinAutoLogin);
};


module.exports = proto.gcloud.oauth;

